%Program to segment an image using k-means clustering
%CLUSNO = 3
%CLUSNO = 5
CLUSNO = 7

%Read image  
%im = imread('C:\601CompGraphics\Wk7\Assn7a\tiger.jpg'); 
%im = imread('C:\601CompGraphics\Wk7\Assn7a\landscape.jpg');
im = imread('C:\601CompGraphics\Wk7\Assn7a\plane.jpg');
figure; imshow(im);

[x, y, z] = size(im);           %Find the size of image

imagemodified = reshape(im, x*y, z);     
im = double(im);                
imagemodified = double(imagemodified);            

[distance,label,tse] = kmeans1(imagemodified, CLUSNO);
                                %Call kmeans1 algorithm to cluster the reshaped image
convimage = reshape(label, x, y);    %Convert back to 3D

[x, y]=size(convimage);            

for i = 1:CLUSNO                
    for j = 1:z                 %in each of the 3 RGB planes = 0
        cmean(i,j) = 0;
    end
    cluster(i) = 0;            
end

%calculate the mean value for the color of each region
for i = 1:x
    for j = 1:y
        index = convimage(i,j);         %Read the cluster no. for each pixel
        for z = 1:3
	        cmean(index,z) = cmean(index,z)+im(i,j,z);
	    end                       
        cluster(index) = cluster(index) + 1;
    end                          
end

 %Calculate mean by dividing the no. of pixels
for i = 1:CLUSNO
    for j = 1:z
       cmean(i,j) = cmean(i,j)/cluster(i);
    end                           
end

%Give the mean color to each pixel
for i = 1:x
    for j = 1:y
        index = convimage(i, j);        
	    for z = 1:3               
	        result(i, j, z) = cmean(index,z);
    	end
    end
end

%Show output
figure; imshow(uint8(result));      